; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "ASR-5300"
!define PRODUCT_VERSION "1.0.1.23"
!define PRODUCT_PUBLISHER "Advantec"
!define PRODUCT_WEB_SITE "www.advantech.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\updateVss.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "Icon_msi.ico"
!define MUI_UNICON "Icon_msi.ico"



; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH


; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Var STR_HAYSTACK
Var STR_NEEDLE
Var STR_CONTAINS_VAR_1
Var STR_CONTAINS_VAR_2
Var STR_CONTAINS_VAR_3
Var STR_CONTAINS_VAR_4
Var STR_RETURN_VAR

Function StrContains
  Exch $STR_NEEDLE
  Exch 1
  Exch $STR_HAYSTACK
  ; Uncomment to debug
  ;MessageBox MB_OK 'STR_NEEDLE = $STR_NEEDLE STR_HAYSTACK = $STR_HAYSTACK '
    StrCpy $STR_RETURN_VAR ""
    StrCpy $STR_CONTAINS_VAR_1 -1
    StrLen $STR_CONTAINS_VAR_2 $STR_NEEDLE
    StrLen $STR_CONTAINS_VAR_4 $STR_HAYSTACK
    loop:
      IntOp $STR_CONTAINS_VAR_1 $STR_CONTAINS_VAR_1 + 1
      StrCpy $STR_CONTAINS_VAR_3 $STR_HAYSTACK $STR_CONTAINS_VAR_2 $STR_CONTAINS_VAR_1
      StrCmp $STR_CONTAINS_VAR_3 $STR_NEEDLE found
      StrCmp $STR_CONTAINS_VAR_1 $STR_CONTAINS_VAR_4 done
      Goto loop
    found:
      StrCpy $STR_RETURN_VAR $STR_NEEDLE
      Goto done
    done:
   Pop $STR_NEEDLE ;Prevent "invalid opcode" errors and keep the
   Exch $STR_RETURN_VAR
FunctionEnd

!macro _StrContainsConstructor OUT NEEDLE HAYSTACK
  Push "${HAYSTACK}"
  Push "${NEEDLE}"
  Call StrContains
  Pop "${OUT}"
!macroend

!define StrContains '!insertmacro "_StrContainsConstructor"'

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_NAME}-v${PRODUCT_VERSION}_x86.exe"
InstallDir "$PROGRAMFILES\Advantec\ASR-5300\"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "vss\atl71.dll"
  File "vss\IFT_WMI.dll"
  File "vss\VSS_Agent.exe"
  File "vss\x86\VSS_HWPRV_EXE.exe"
  CreateDirectory "$SMPROGRAMS\Advantec"
  ExecWait "$INSTDIR\VSS_Agent.exe /RegServer"
  ExecWait "$INSTDIR\VSS_HWPRV_EXE.exe /RegServer"
  ;SimpleSC::InstallService "Eonpath Agent Service" "Eonpath Agent Service" "16" "2" "$INSTDIR\MPIO_Agent.exe" "RPCSS" "" ""
  ;SimpleSC::StartService "Eonpath Agent Service" ""
  ;Pop $0 ; returns an errorcode (<>0) otherwise success (0)
SectionEnd

Section -Post
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\update.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\uninstall.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\uninstall.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

;var Result
Function .onInit
;Version::IsWindows2003
;  Pop $Result
;  StrCmp $Result "1" Label_ItIsWindows2003 Label_ItIsNotWindows2003
;Label_ItIsNotWindows2003:
;  MessageBox MB_OK 'Error! This package is only for Windows Server 2003!'
;  Abort
;Label_ItIsWindows2003:
${StrContains} $0 "Program Files (x86)" $PROGRAMFILES
  StrCmp $0 "" notfound
  MessageBox MB_OK 'Error! This package can not install on X64 host!'
  Abort
notfound:
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) has been removed completely."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure to remove $(^Name) and all of the components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  ExecWait "$INSTDIR\VSS_HWPRV_EXE.exe /UnregServer"
  ExecWait "$INSTDIR\VSS_Agent.exe /UnregServer"
  RMDir "$SMPROGRAMS\Advantec\"

  ;SimpleSC::StopService "Eonpath Agent Service"
  ;Pop $0 ; returns an errorcode (<>0) otherwise success (0)
  ;SimpleSC::RemoveService  "Eonpath Agent Service"
  ;Pop $0 ; returns an errorcode (<>0) otherwise success (0)
  
  Delete "$INSTDIR\VSS_Agent.exe"
  Delete "$INSTDIR\VSS_HWPRV_EXE.exe"
  Delete "$INSTDIR\IFT_WMI.dll"
  Delete "$INSTDIR\atl71.dll"
  Delete "$INSTDIR\uninst.exe"
  RMDir "$INSTDIR"
  RMDir "$PROGRAMFILES\Advantec\"
  
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}"
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd